config/routes.rb
# frozen_string_literal: true
Rails.application.routes.draw do
  resources :organizations

  resources :organizations, only: [] do
    resources :item_types do
      get 'graph_map', controller: 'states'
    end

    resources :item_types, only: [], path: '' do
      match 'summary', to: 'item_types#summary', via: :get
      resources :states
      resources :items, path: ''
    end
  end

  root 'home#index'
  match 'home/private_index' => 'home#private_index', via: :get

  # omniauth
  get '/auth/:provider/callback' => 'user_sessions#create'
  get '/auth/failure' => 'user_sessions#failure'
  get 'auth/autologin' => 'user_sessions#autologin'

  # Custom logout
  match '/logout', to: 'user_sessions#destroy', via: :all
end

app/models/item.rb
# frozen_string_literal: true
class Item < ApplicationRecord
  # t.string   "name",         null: false
  # t.integer  "item_type_id", null: false
  # t.integer  "state_id",     null: false
  # t.datetime "created_at",   null: false
  # t.datetime "updated_at",   null: false
  # t.index ["item_type_id", "name"], name: "index_items_on_item_type_id_and_name",
  # unique: true, using: :btree
  # t.index ["item_type_id"], name: "index_items_on_item_type_id", using: :btree
  # t.index ["state_id"], name: "index_items_on_state_id", using: :btree

  # validations
  validates :name, presence: true, uniqueness: { scope: :item_type }
  validates :item_type, :state, presence: true

  # relations
  belongs_to :item_type
  belongs_to :state

  # callbacks
  before_validation :set_initial_state, on: :create

  delegate :reachable_states, to: :state

  private

  def set_initial_state
    self.state ||= item_type.initial_state || item_type.states.first
  end
end

app/models/item_type.rb
# frozen_string_literal: true
class ItemType < ApplicationRecord
  extend FriendlyId
  # t.string   "title",            null: false
  # t.datetime "created_at",       null: false
  # t.datetime "updated_at",       null: false
  # t.integer  "organization_id",  null: false
  # t.integer  "initial_state_id"
  # t.index ["initial_state_id"], name: "index_item_types_on_initial_state_id", using: :btree
  # t.index ["organization_id"], name: "index_item_types_on_organization_id", using: :btree

  # validations
  validates :title, presence: true, uniqueness: { scope: :organization }
  validates :organization, presence: true
  validates :initial_state, presence: true, if: :states?

  validate :forbid_changing_title, on: :update

  # relations
  belongs_to :organization
  has_many :states, dependent: :restrict_with_exception
  has_many :items, dependent: :restrict_with_exception
  belongs_to :initial_state, class_name: 'State'

  # callbacks
  before_destroy :delete_states
  after_create :create_sample_state

  # rest instance methods
  friendly_id :title, use: :slugged
  alias_attribute :slug, :title

  attr_accessor :sample_state_service

  def states?
    states.present?
  end

  private

  def forbid_changing_title
    errors.add(:title, 'can not be changed!') if title_changed?
  end

  def delete_states
    update(initial_state_id: nil)
    states.destroy_all
  end

  def create_sample_state
    State.create(name: 'new', item_type: self, color: '11FF11')

    begin
      service = "#{sample_state_service}Service".constantize
      service.new(organization).perform if defined?(service)
    rescue NameError
      # if it fails here it means that service cannot be found, we just ignore this
      nil
    end
  end
end

app/controllers/items_controller.rb
# frozen_string_literal: true
class ItemsController < ApplicationController
  before_action :set_organization
  before_action :set_item_type
  before_action :set_item, only: [:show, :edit, :update, :destroy]

  # GET /items
  # GET /items.json
  def index
    @items = @item_type.items.all.includes(:state)
  end

  # GET /items/1
  # GET /items/1.json
  def show; end

  # GET /items/new
  def new
    @item = @item_type.items.new
  end

  # GET /items/1/edit
  def edit; end

  # POST /items
  # POST /items.json
  def create
    @item = @item_type.items.new(item_params)

    respond_to do |format|
      if @item.save
        format.html do
          redirect_to [@organization, @item_type, @item],
                      notice: 'Item was successfully created.'
        end
        format.json { render :show, status: :created, location: [@organization, @item_type, @item] }
      else
        format.html { render :new }
        format.json { render json: @item.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /items/1
  # PATCH/PUT /items/1.json
  def update
    respond_to do |format|
      if @item.update(item_params)
        format.html do
          redirect_to [@organization, @item_type, @item],
                      notice: 'Item was successfully updated.'
        end
        format.json { render :show, status: :ok, location: [@organization, @item_type, @item] }
      else
        format.html { render :edit }
        format.json { render json: @item.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /items/1
  # DELETE /items/1.json
  def destroy
    raise 'Cannot delete item, it can be done anly by api.' unless json_request?
    head :no_content if @item.destroy.save
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_item
    @item = @organization.item_types.friendly.find(params[:item_type_id]).items.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def item_params
    params.require(:item).permit(:name, :state_id)
  end
end

app/helpers/items_helper.rb
# frozen_string_literal: true
module ItemsHelper
end

app/views/items/_form.html.haml
= form_for [organization, item_type, item] do |f|
  - if item.errors.any?
    #error-explanation
      %h2= pluralize(item.errors.count, 'error')
      prohibited this item from being saved:
      %ul
        - item.errors.full_messages.each do |msg|
          %li= msg

  .field
    = f.label :name
    = f.text_field :name
  - unless action_name == 'new'
    .field
      = f.label :state
      = f.collection_select :state_id, item_type.states, :id, :name
  .actions
    = f.submit 'Save'

app/views/items/edit.html.haml
%h1 Editing item

= render 'form',  organization: @organization, item_type: @item_type,
item: @item

= link_to 'Show', [@organization, @item_type, @item]
\|
= link_to 'Back', organization_item_type_items_path(@organization, @item_type)

app/views/items/index.html.haml
%h1 Listing items

%table
  %thead
    %tr
      %th Name
      %th Item type
      %th State
      %th
      %th
      %th

  %tbody
    - @items.each do |item|
      %tr
        %td= item.name
        %td= item.item_type.title
        %td= item.state.name
        %td= link_to 'Show', [@organization, @item_type, item]
        %td= link_to 'Edit',
        edit_organization_item_type_item_path(@organization, @item_type, item)

%br

= link_to 'New Item', new_organization_item_type_item_path(@organization,
@item_type)
%br
= link_to "All #{@item_type.title} (back)",
organization_item_type_path(@organization, @item_type)

app/views/items/new.html.haml
%h1 New item

= render 'form',  organization: @organization, item_type: @item_type,
item: @item

= link_to 'Back', organization_item_type_items_path(@organization,
@item_type)

app/views/items/show.html.haml
%p#notice= notice

%p
  %b Name:
  = @item.name
%p
  %b Item type:
  = @item.item_type.title
%p
  %b State:
  = @item.state.name
%p
  %b Reachable States:
  = @item.reachable_states.count

= link_to 'Edit', edit_organization_item_type_item_path(@organization,
@item_type, @item)
\|
= link_to 'Back', organization_item_type_items_path(@organization, @item_type)